/* (C) Peter Mueller / sinelabore.com */
/* Command line options: -U toggle.cfg -p CADIFRA -o toggle toggle.cdd   */
/* This file is generated from toggle.cdd - do not edit manually*/
/* Generated on: Thu Jan 01 23:23:39 CET 2015 / version 3.6.7 */


#ifndef __TOGGLE_H__
#define __TOGGLE_H__


/* Header to define simple data types */
#include <stdint.h>

/* State definitions */
typedef enum{
	PowerFail,
	PFLedHigh,
	PFLedLow,
	Step1,
	Step2,
	Running,
	__TOGGLE_LAST_STATE__} TOGGLE_STATES_T;






/* Predefined types required by the codegen. You can provide your own  */
/* definitions by setting the following define somewhere in your built env. */
#ifndef __PROVIDE_OWN_TOGGLE_STATEMACHINE_TYPES__
	typedef uint8_t TOGGLE_ENTRY_FLAG_T;
	typedef TOGGLE_STATES_T TOGGLE_STATEVAR_T;
	typedef uint8_t TOGGLE_INST_ID_T;
	typedef uint8_t TOGGLE_EV_CONSUMED_FLAG_T ;
	typedef unsigned char TOGGLE_EVENT_T;
#endif




/* Instance data definition of state machine */
typedef struct{
	TOGGLE_ENTRY_FLAG_T runningEntry;
	TOGGLE_STATEVAR_T stateVar;
	TOGGLE_STATEVAR_T stateVarRunning;
	TOGGLE_STATEVAR_T stateVarPowerFail;
	TOGGLE_INST_ID_T inst_id;
} TOGGLE_INSTANCEDATA_T;

/* Helper to initialize the machine's instance data */
#define TOGGLE_INSTANCEDATA_INIT {\
	1,\
	(TOGGLE_STATEVAR_T) Running /* set init state of top state */,\
	(TOGGLE_STATEVAR_T) Step1 /* set init state of Running */,\
	(TOGGLE_STATEVAR_T) PFLedHigh /* set init state of PowerFail */,\
	0 /* instance id */ } 

/* Helper(s) to reset history */
#define TOGGLE_RESET_HISTORY_RUNNING(instance) ((&instance)->stateVarRunning=Step1)
#define TOGGLE_RESET_HISTORY_POWERFAIL(instance) ((&instance)->stateVarPowerFail=PFLedHigh)
/* Region handler prototypes  */

/*Prototype of the state machine function */
void  toggle(TOGGLE_INSTANCEDATA_T *instanceVar, TOGGLE_EVENT_T msg);


/*Prototoye of the reset machine function */
void toggleResetMachine(TOGGLE_INSTANCEDATA_T *instanceVar);

// Helper(s) to reset history
void toggleResetHistoryRunning(TOGGLE_INSTANCEDATA_T *instanceVar);
void toggleResetHistoryPowerFail(TOGGLE_INSTANCEDATA_T *instanceVar);

// Helper(s) to find out if the machine is in a certain state
uint8_t toggleIsInPowerFail(TOGGLE_INSTANCEDATA_T *instanceVar);
uint8_t toggleIsInPFLedHigh(TOGGLE_INSTANCEDATA_T *instanceVar);
uint8_t toggleIsInPFLedLow(TOGGLE_INSTANCEDATA_T *instanceVar);
uint8_t toggleIsInStep1(TOGGLE_INSTANCEDATA_T *instanceVar);
uint8_t toggleIsInStep2(TOGGLE_INSTANCEDATA_T *instanceVar);
uint8_t toggleIsInRunning(TOGGLE_INSTANCEDATA_T *instanceVar);


/* Macros to test if the machine is in a certain state. */
#define TOGGLE_IS_IN_POWERFAIL(instance)((((&instance)->stateVar==PowerFail)) ? (1U) : (0U))
#define TOGGLE_IS_IN_PFLEDHIGH(instance)((((&instance)->stateVarPowerFail==PFLedHigh)&&((&instance)->stateVar==PowerFail)) ? (1U) : (0U))
#define TOGGLE_IS_IN_PFLEDLOW(instance)((((&instance)->stateVarPowerFail==PFLedLow)&&((&instance)->stateVar==PowerFail)) ? (1U) : (0U))
#define TOGGLE_IS_IN_STEP1(instance)((((&instance)->stateVarRunning==Step1)&&((&instance)->stateVar==Running)) ? (1U) : (0U))
#define TOGGLE_IS_IN_STEP2(instance)((((&instance)->stateVarRunning==Step2)&&((&instance)->stateVar==Running)) ? (1U) : (0U))
#define TOGGLE_IS_IN_RUNNING(instance)((((&instance)->stateVar==Running)) ? (1U) : (0U))


/* Helper returning the innermost active state.*/
TOGGLE_STATES_T toggleGetInnermostActiveState(TOGGLE_INSTANCEDATA_T *instanceVar);

#endif
