/* (c) Peter Mueller, 2014 - All rights reserved. Reproduction, modification,
   use or disclosure to third parties without express
   authority is forbidden.
 */

#include "ringbuf.h"


uint8_t fifoPut(FIFO_T *buffer, uint8_t byte){
    
    uint8_t next = ((buffer->write + 1) & buffer->mask);
    if (buffer->read == next)
        return 1;
    buffer->data[buffer->write] = byte;
    buffer->write = next;
    return 0;
}

uint8_t fifoPutHead(FIFO_T *buffer,  uint8_t byte){
    uint8_t next = ((buffer->read - 1) & buffer->mask);
    
    if(next == buffer->write){
        return 1;
    }
    
    buffer->data[next] = byte;
    buffer->read = next;
    return 0;
}

uint8_t fifoGet(FIFO_T *buffer, uint8_t *pByte){
    if (buffer->read == buffer->write)
        return 1;
    *pByte = buffer->data[buffer->read];
    buffer->read = (buffer->read+1) & buffer->mask;
    return 0;
}



void fifoInit(FIFO_T *buffer, uint8_t *pByte, uint8_t size){
    buffer->data = pByte;
    buffer->mask  = size-1;
    buffer->read=0;
    buffer->write = 0;
}
